#include "widget.h"
#define MAX_NUMBER_LENGTH 20

Widget::Widget(QWidget *parent) : QWidget(parent) {
 QGridLayout *my = new QGridLayout();
 QLabel *labelHelp = new QLabel(QString(tr("Заполни все кнопки с цифрами различными \
 между собой простыми числами. По нажатию кнопки число с неё дописывается в заголовок окна \
 (до %1 символов). Если в заголовке получилось простое число, оно возвращается на кнопку,\
 а заголовок очищается. Начинать строку заголовка с уже имеющегося простого числа нельзя, \
 кроме семёрки").arg(MAX_NUMBER_LENGTH)));
 labelHelp->setWordWrap(true);
 int stuff[9] = { 1, 7, 1, 7, 9, 7, 1, 7, 1 }; //Начальные числа для заполнения сетки
 mainStyle="font-size: 12pt; font-weight: bold;";

 for (int i=0; i<9; i++) {
  data[i] = stuff[i]; //Глобальная копия начальных чисел
  QPushButton *btn = CreateButton(QString(tr("%1")).arg(data[i]));
  btn->setStyleSheet(mainStyle);
  my->addWidget(btn,i%3,i/3);
  List.append(btn);
 }
 my->addWidget(labelHelp,3,0,1,3);
 QPushButton *clearBtn = new QPushButton(QString(tr("Заново")));
 connect(clearBtn,SIGNAL(clicked()),this,SLOT(clearBtnClicked()));
 QPushButton *clear1Btn = new QPushButton(QString(tr("Стереть")));
 connect(clear1Btn,SIGNAL(clicked()),this,SLOT(clear1BtnClicked()));
 labelCount = new QLabel(QString(tr("Счёт: 0")));
 my->addWidget(clearBtn,4,0);
 my->addWidget(clear1Btn,4,1);
 my->addWidget(labelCount,4,2);
 setLayout(my);
 cnt = 0;
 setWindowTitle(QString(tr("")));
}

QPushButton *Widget::CreateButton (QString str) {
 QPushButton *b = new QPushButton(str);
 b->setMinimumWidth(60); b->setMaximumHeight(120);
 connect(b,SIGNAL(clicked()),this,SLOT(buttonClicked()));
 return b;
}

void Widget::buttonClicked() {
 cnt++; labelCount->setText(tr("Счёт: ")+QString::number(cnt));

 QString s = ((QPushButton *)sender())->text();
 QString c = windowTitle();
 if (c.length()+s.length()<MAX_NUMBER_LENGTH) {
  setWindowTitle(c+s);
  c=windowTitle();
  if (simple(c.toInt())) {
   ((QPushButton *)sender())->setText(c);
   if (c.size()>1) setWindowTitle(QString(tr("")));
   ((QPushButton *)sender())->setStyleSheet(mainStyle+QString("color: green;"));
  }
 }
 else {
  ((QPushButton *)sender())->setStyleSheet(mainStyle+QString("color: red;"));
 }

 bool win = true;
 for (int i=0; i<9; i++) {
  QPushButton *b = List.at(i);
  if (!simple(b->text().toInt())) {
   win = false;
   ((QPushButton *)sender())->setStyleSheet(mainStyle+QString("color: green;"));
  }
  else {
   ((QPushButton *)sender())->setStyleSheet(mainStyle+QString("color: black;"));
  }
 }
 bool win2 = true;
 for (int i=0; i<8; i++) {
  QPushButton *bi = List.at(i);
  for (int j=i+1; j<9; j++) {
   QPushButton *bj = List.at(j);
   if (bi->text()==bj->text()) {
     bj->setStyleSheet(mainStyle+QString("color: red;"));
     win2 = false;
   }
  }
 }
 if (win && win2) {
  setWindowTitle(QString(tr("Вы победили! Счёт=%1")).arg(cnt));
  for (int i=0; i<9; i++) {
   QPushButton *bi = List.at(i);
   bi->setStyleSheet(mainStyle+QString("color: green;"));
   bi->setEnabled(false);
  }
 }
}

bool Widget::simple (int n) {
 if (n<2) return false;
 if (n<4) return true;
 if (n%2==0) return false;
 int limit=qSqrt(n/2);
 for (int i=3; i<limit; i+=2) if (n%i==0) return false;
 return true;
}

void Widget::clearBtnClicked() {
 cnt = 0; labelCount->setText(tr("Счёт: ")+QString::number(0));
 for (int i=0; i<9; i++) {
  QPushButton *bi = List.at(i);
  bi->setText(QString(tr("%1")).arg(data[i]));
  bi->setStyleSheet(mainStyle+QString("color: black;"));
  bi->setEnabled(true);
 }
 setWindowTitle(QString(tr("")));
}

void Widget::clear1BtnClicked() {
 setWindowTitle(QString(tr("")));
}

Widget::~Widget() {}
